import Errors from './Errors';
import Request from './Request';
export declare enum FormMethods {
    POST = "post",
    PATCH = "patch",
    PUT = "put"
}
export interface FormConfig {
    resetAfterSend?: boolean;
    removeNullValues?: boolean;
    method?: FormMethods;
    request?: Request;
}
export interface FormData {
    [key: string]: any;
}
export default class Form {
    data: FormData;
    originalData: FormData;
    config: FormConfig;
    errors: Errors;
    request: Request;
    /**
     * Create a new Form instance.
     */
    constructor(data: FormData, config?: FormConfig);
    /**
     * Add a new field with value to the form.
     */
    addField(field: string, value: any): void;
    /**
     * Get FormData object.
     */
    getFormData(): FormData;
    reset(): void;
    serialize(): string;
    submit(url: string): Promise<unknown>;
}
